#!/bin/bash
N=$1
windows_sz=$2
alpha=$3
theta=$4
quantile=$5


# Main algorithm
jpegblocks $N input_0.png $windows_sz $alpha $theta $quantile

# Draw plots
draw2Dcurve.py output_twocol_horz.txt --markers=0 --xName="Pixels" --yName="Sum" --title="Horizontal plot" --output=horz_plot.png
draw2Dcurve.py output_twocol_horz_med.txt --markers=0 --xName="Pixels" --yName="Sum" --title="Horizontal plot after median filtering" --output=output_twocol_horz_med.png
draw2Dcurve.py output_twocol_horz_med_centered.txt --markers=0 --xName="Pixels" --yName="Sum" --title="Horizontal plot after centering" --output=output_twocol_horz_med_centered.png

draw2Dcurve.py output_twocol_vert.txt --markers=0 --xName="Pixels" --yName="Sum" --title="Vertical plot" --output=vert_plot.png
draw2Dcurve.py output_twocol_vert_med.txt --markers=0 --xName="Pixels" --yName="Sum" --title="Vertical plot after median filtering" --output=output_twocol_vert_med.png
draw2Dcurve.py output_twocol_vert_med_centered.txt --markers=0 --xName="Pixels" --yName="Sum" --title="Vertical plot after centering" --output=output_twocol_vert_med_centered.png

# Draw the plots used for comparison
draw2Dcurve.py output_NFA_horz.txt --title="Horizontal NFA plot" --xName="Index" --yName="NFA" --legend="Method 1, Method 2, Method 3" --output=output_NFA_horz.png
draw2Dcurve.py output_NFA_vert.txt --title="Vertical NFA plot" --xName="Index" --yName="NFA" --legend="Method 1, Method 2, Method 3" --output=output_NFA_vert.png
draw2Dcurve.py output_histogram_horz.txt --title="Horizontal histogram" --xName="Index" --yName="Count" --legend="Method 1, Method 2, Method 3" --output=output_histogram_horz.png
draw2Dcurve.py output_histogram_vert.txt --title="Vertical histogram" --xName="Index" --yName="Count" --legend="Method 1, Method 2, Method 3" --output=output_histogram_vert.png
