clc ; clear ; close all ;
%% verification 
output_twocol_horz = textread('output_twocol_horz.txt') ;
output_twocol_vert = textread('output_twocol_vert.txt') ;
output_twocol_horz_med = textread('output_twocol_horz_med.txt') ;
output_twocol_vert_med = textread('output_twocol_vert_med.txt') ;
output_twocol_horz_med_centered = textread('output_twocol_horz_med_centered.txt') ;
output_twocol_vert_med_centered = textread('output_twocol_vert_med_centered.txt') ;

size_plt = 200 ;

figure
subplot(1,3,1)
plot(1:1:size_plt, output_twocol_horz(1:size_plt)) ;
subplot(1,3,2)
plot(1:1:size_plt, output_twocol_horz_med(1:size_plt)) ;
subplot(1,3,3)
plot(1:1:size_plt, output_twocol_horz_med_centered(1:size_plt)) ;

figure
subplot(1,3,1)
plot(1:1:size_plt, output_twocol_vert(1:size_plt)) ;
subplot(1,3,2)
plot(1:1:size_plt, output_twocol_vert_med(1:size_plt)) ;
subplot(1,3,3)
plot(1:1:size_plt, output_twocol_vert_med_centered(1:size_plt)) ;

%% find the peaks
std_horz = std(output_twocol_horz_med_centered) 
std_vert = std(output_twocol_vert_med_centered) 
%peaks_horz = output_twocol_horz_med_centered>quantile(output_twocol_horz_med_centered,0.9) ;
peaks_horz = output_twocol_horz_med_centered>std_horz ;
quantile_horz = quantile(output_twocol_horz_med_centered,0.9) 
%peaks_vert = output_twocol_vert_med_centered>quantile(output_twocol_vert_med_centered,0.9) ;
peaks_vert = output_twocol_vert_med_centered>std_vert ;
quantile_vert = quantile(output_twocol_vert_med_centered,0.9) 
%peaks_horz = output_twocol_horz_med_centered.*peaks_horz ; 

figure
subplot(1,2,1)
plot(peaks_horz(1:size_plt)) ; 
title('Horizontal Peaks') ;
subplot(1,2,2)
plot(peaks_vert(1:size_plt)) ; 
title('Vertical Peaks') ;
%% compute the NFA
hist_horz = zeros(8,1) ; 
for i = 1:8
    hist_horz(mod(i+2,8)+1) = sum(peaks_horz(i:8:end)) ; 
end
NFA_horz = zeros(8,1) ;
for i =1:8
    NFA_horz(i) = log(16*binomial_sum(sum(peaks_horz), hist_horz(i), 1/8)) ;
end

hist_vert = zeros(8,1) ; 
for i = 1:8
    hist_vert(mod(i+2,8)+1) = sum(peaks_vert(i:8:end)) ; 
end
NFA_vert = zeros(8,1) ;
for i =1:8
    NFA_vert(i) = log(16*binomial_sum(sum(peaks_vert), hist_vert(i), 1/8)) ;
end
figure
subplot(1,2,1)
plot(NFA_horz, 'o') ; grid on ; 
title('log(NFA) - horizontal')
subplot(1,2,2)
plot(NFA_vert, 'o') ; grid on ; 
title('log(NFA) - vertical') 
%% Test of the histograms
clc ; 
histogram_horz = textread('histogram_horz.txt') ;
histogram_vert = textread('histogram_vert.txt') ; 
figure
subplot(1,2,1)
plot(histogram_horz, 'ok') ;
title('histogram horz') ;
subplot(1,2,2)
plot(histogram_vert, 'ok') ;
title('histogram vert') ;
%% comparing the results wit the C code 
img_test = imread('pelican.png') ;
nrow = floor( size(img_test, 1) / 8 ) 
ncol = floor( size(img_test, 2) / 8 ) 
test_horz_order = textread('test_horz_order.txt') ;
test_vert_order = textread('test_vert_order.txt') ;
figure
plot(test_horz_order(1:end-1)) ; 
figure
plot(test_vert_order(1:end-1)) ; 
%%
test_maxima_horz = textread('./test_maxima_horz.txt') ;
test_maxima_vert = textread('./test_maxima_vert.txt') ;
sum(test_maxima_horz) 
sum(test_maxima_vert) 
%%
Im_WN = cat(3, randn(1000), randn(1000),randn(1000)) ;
imwrite(Im_WN, 'im_wn.png', 'quality', 'lossless') ; 
%% 
im_in = imread('register.jpg') ;
for i=50:10:200
   name_i = strcat('im_in', num2str(i),'.png') ;
   imwrite(im_in(1:i, 1:i, :), name_i, 'quality', 'lossless') ;
end